PYCDLIB-GENISOIMAGE(1)

NAME
pycdlib-genisoimage - tool to master ISOs using pycdlib

SYNOPSIS
pycdlib-genisoimage [options] [-o filename] pathspec [pathspec ...]

DESCRIPTION
pycdlib-genisoimage is a pre-mastering program to generate ISO9660/Joliet/HFS hybrid filesystems. It is meant to be 100% flag-compatible with the original genisoimage program so that it can be dropped into existing scripts with no changes. Please see the man page for genisoimage for more detailed explanation of the options to this program. There are a few differences to note between this program and the original genisoimage. First, not all of the options are implemented in this program. This means that pycdlib-genisoimage will silently ignore some flags; for the most common usage of this program, this will not matter. However, if you are trying to do something odd and specific, it may not work. The flags that this applies to are noted in the OPTIONS below. In some cases these flags can be implemented with a bit of work, and in some cases the flags can never be implemented due to the design of pycdlib. If in doubt, please ask on https://github.com/clalancette/pycdlib/issues. Second, pycdlib-genisoimage does not output all of the same messages to standard out/standard error that genisoimage does. Any program that relies on parsing the output of genisoimage will probably not work. Third, pycdlib-genisoimage will not always generate ISOs that are 100% the same as the genisoimage counterparts. This is for a variety of reasons, ranging from bug fixing to simple differences in implementations. In almost all cases this does not matter, but please keep it in mind when using this program instead of genisoimage.

OPTIONS

-abstract file
    Specifies the abstract filename. There is space for 37 characters.

-A application_id

-appid application_id
    Specifies a text string that will be written into the volume header. This should describe the application that will be on the disc. There is space for 128 characters.

-allow-limited-size
    (not supported by pycdlib-genisoimage) When processing files larger than 2GiB which cannot be easily represented in ISO9660, add them with a shrunk visible file size to ISO9660 and with the correct visible file size to the UDF system. The result is an inconsistent filesystem and users need to make sure that they really use UDF rather than ISO9660 driver to read a such disk. Implies enabling -udf.

-allow-leading-dots

-ldots
    (not supported by pycdlib-genisoimage) Allow ISO9660 filenames to begin with a period. Usually, a leading dot is replaced with an underscore in order to maintain MS-DOS compatibility.
    This violates the ISO9660 standard, but it happens to work on many systems. Use with caution.

-allow-lowercase
    (not supported by pycdlib-genisoimage) This options allows lowercase characters to appear in ISO9660 filenames.
    This violates the ISO9660 standard, but it happens to work on some systems. Use with caution.

-allow-multidot
    (not supported by pycdlib-genisoimage) This options allows more than one dot to appear in ISO9660 filenames. A leading dot is not affected by this option, it may be allowed separately using -allow-leading-dots.
    This violates the ISO9660 standard, but it happens to work on many systems. Use with caution.

-biblio file
    Specifies the bibliographic filename. There is space for 37 characters.

-cache-inodes

-no-cache-inodes
    (not supported by pycdlib-genisoimage) Enable or disable caching inode and device numbers to find hard links to files. If pycdlib-genisoimage finds a hard link (a file with multiple names), the file will also be hard-linked on the CD, so the file contents only appear once. This helps to save space. -cache-inodes is default on Unix-like operating systems, but -no-cache-inodes is default on some other systems such as Cygwin, because it is not safe to assume that inode numbers are unique on those systems. (Some versions of Cygwin create fake inode numbers using a weak hashing algorithm, which may produce duplicates.) If two files have the same inode number but are not hard links to the same file, pycdlib-genisoimage -cache-inodes will not behave correctly. -no-cache-inodes is safe in all situations, but in that case pycdlib-genisoimage cannot detect hard links, so the resulting CD image may be larger than necessary.

-alpha-boot alpha_boot_image
    (not supported by pycdlib-genisoimage) Specifies the path and filename of the boot image to be used when making an Alpha/SRM bootable CD. The pathname must be relative to the source path specified to pycdlib-genisoimage.

-hppa-bootloader hppa_bootloader_image
    (not supported by pycdlib-genisoimage) Specifies the path and filename of the boot image to be used when making an HPPA bootable CD. The pathname must be relative to the source path specified to pycdlib-genisoimage. Other options are required, at the very least a kernel filename and a boot command line.

-hppa-cmdline hppa_boot_command_line
    (not supported by pycdlib-genisoimage) Specifies the command line to be passed to the HPPA boot loader when making a bootable CD. Separate the parameters with spaces or commas. More options must be passed to pycdlib-genisoimage, at the very least a kernel filename and the boot loader filename.

-hppa-kernel-32 hppa_kernel_32

-hppa-kernel-64 hppa_kernel_64
    (not supported by pycdlib-genisoimage) Specifies the path and filename of the 32-bit and/or 64-bit kernel images to be used when making an HPPA bootable CD. The pathnames must be relative to the source path specified to pycdlib-genisoimage. Other options are required, at the very least the boot loader filename and the boot command line.

-hppa-ramdisk hppa_ramdisk_image
    (not supported by pycdlib-genisoimage) Specifies the path and filename of the ramdisk image to be used when making an HPPA bootable CD. The pathname must be relative to the source path specified to pycdlib-genisoimage. This parameter is optional. Other options are required, at the very least a kernel filename and the boot command line.

-mips-boot mips_boot_image
    (not supported by pycdlib-genisoimage) Specifies the path and filename of the boot image to be used when making an SGI/big-endian MIPS bootable CD. The pathname must be relative to the source path specified to pycdlib-genisoimage. This option may be specified several times, to store up to 15 boot images.

-mipsel-boot mipsel_boot_image
    (not supported by pycdlib-genisoimage) Specifies the path and filename of the boot image to be used when making an DEC/little-endian MIPS bootable CD. The pathname must be relative to the source path specified to pycdlib-genisoimage.

-B img_sun4,img_sun4c,img_sun4m,img_sun4d,img_sun4e

-sparc-boot img_sun4,img_sun4c,img_sun4m,img_sun4d,img_sun4e
    (not supported by pycdlib-genisoimage) Specifies a comma-separated list of boot images that are needed to make a bootable CD for SPARC systems. Partition 0 is used for the ISO9660 image, the first image file is mapped to partition 1. The comma-separated list may have up to 7 fields, including empty fields. This option is required to make a bootable CD for Sun SPARC systems. If -B or -sparc-boot has been specified, the first sector of the resulting image will contain a Sun disk label. This disk label specifies slice 0 for the ISO9660 image and slices 1 to 7 for the boot images that have been specified with this option. Byte offsets 512 to 8191 within each of the additional boot images must contain a primary boot that works for the appropriate SPARC architecture. The rest of each of the images usually contains a UFS filesystem used for the primary kernel boot stage.

    The implemented boot method is the one found with SunOS 4.x and SunOS 5.x. However, it does not depend on SunOS internals but only on properties of the Open Boot prom, so it should be usable for any OS for SPARC systems. For more information also see the NOTES section below.

    If the special filename ... is used, the actual and all following boot partitions are mapped to the previous partition. If pycdlib-genisoimage is called with -G image -B ... all boot partitions are mapped to the partition that contains the ISO9660 filesystem image and the generic boot image that is located in the first 16 sectors of the disc is used for all architectures.

-G generic_boot_image
    (not supported by pycdlib-genisoimage) Specifies the path and filename of the generic boot image to be used when making a generic bootable CD. The boot image will be placed on the first 16 sectors of the CD, before the ISO9660 primary volume descriptor. If this option is used together with -sparc-boot, the Sun disk label will overlay the first 512 bytes of the generic boot image.

-b eltorito_boot_image

-eltorito-boot eltorito_boot_image
    Specifies the path and filename of the boot image to be used when making an El Torito bootable CD for x86 PCs. The pathname must be relative to the source path specified to pycdlib-genisoimage. This option is required to make an El Torito bootable CD. The boot image must be exactly 1200 kB, 1440 kB or 2880 kB, and pycdlib-genisoimage will use this size when creating the output ISO9660 filesystem. The PC BIOS will use the image to emulate a floppy disk, so the first 512-byte sector should contain PC boot code. This will work, for example, if the boot image is a LILO-based boot floppy.

    If the boot image is not an image of a floppy, you need to add either -hard-disk-boot or -no-emul-boot. If the system should not boot off the emulated disk, use -no-boot.

    If -sort has not been specified, the boot images are sorted with low priority (+2) to the beginning of the medium. If you don't like this, you need to specify a sort weight of 0 for the boot images.

-eltorito-alt-boot
    Start with a new set of El Torito boot parameters. Up to 63 El Torito boot entries may be stored on a single CD.

-hard-disk-boot
    Specifies that the boot image used to create El Torito bootable CDs is a hard disk image. The image must begin with a master boot record that contains a single partition.

-eltorito-platform id
    (not supported by pycdlib-genisoimage) Set the "El Torito" platform id for a boot record or a section of boot records. The id parameter may be either:

    x86 This is the default platform id value and specifies entries for the PC platform. If no -eltorito-platform option appears before the first -eltorito-boot option, the default boot entry becomes an entry for the x86 PC platform.

    PPC Boot entries for the Power PC platform.

    Mac Boot entries for the Apple Mac platform.

    efi Boot entries for EFI based PCs.

    #   A numeric value specifying any platform id.

    If the option -eltorito-platform appears before the first -eltorito-boot option, it sets the platform id for the default boot entry.

    If the option -eltorito-platform appears after an -eltorito-boot option and sets the platform id to a value different from the previous value, it starts a new set of boot entries.

    The second boot entry and any new platform id creates a new section header and reduces the number of boot entries per CD by one.

-ignore-error
    (not supported by pycdlib-genisoimage) Ignore errors. pycdlib-genisoimage by default aborts on several errors, such as read errors. With this option in effect, pycdlib-genisoimage tries to continue. Use with care.

-no-emul-boot
    Specifies that the boot image used to create El Torito bootable CDs is a "no emulation" image. The system will load and execute this image without performing any disk emulation.

-no-boot
    Specifies that the created El Torito CD should be marked as not bootable. The system will provide an emulated drive for the image, but will boot off a standard boot device.

-boot-load-seg segment_address
    Specifies the load segment address of the boot image for no-emulation El Torito CDs.

-boot-load-size load_sectors
    Specifies the number of "virtual" (512-byte) sectors to load in no-emulation mode. The default is to load the entire boot file. Some BIOSes may have problems if this is not a multiple of 4.

-boot-info-table
    Specifies that a 56-byte table with information of the CD-ROM layout will be patched in at offset 8 in the boot file.

-C last_sess_start,next_sess_start

-cdrecord-params last_sess_start,next_sess_start
    (not supported by pycdlib-genisoimage) This option is needed to create a CD Extra or the image of a second session or a higher-level session for a multisession disc. -C takes two numbers separated by a comma. The first is the first sector in the last session of the disc that should be appended to. The second number is the starting sector number of the new session. The correct numbers may be retrieved by calling wodim -msinfo ... If -C is used in conjunction with -M, pycdlib-genisoimage will create a filesystem image that is intended to be a continuation of the previous session. If -C is used without -M, pycdlib-genisoimage will create a filesystem image that is intended to be used for a second session on a CD Extra. This is a multisession CD that holds audio data in the first session and an ISO9660 filesystem in the second session.

-c boot_catalog

-eltorito-catalog boot_catalog
    Specifies the path and filename of the boot catalog, which is required for an El Torito bootable CD. The pathname must be relative to the source path specified to pycdlib-genisoimage. This file will be inserted into the output tree and not created in the source filesystem, so be sure the specified filename does not conflict with an existing file, or it will be excluded. Usually a name like boot.catalog is chosen.

    If -sort has not been specified, the boot catalog sorted with low priority (+1) to the beginning of the medium. If you don't like this, you need to specify a sort weight of 0 for the boot catalog.

-check-oldnames
    (not supported by pycdlib-genisoimage) Check all filenames imported from the old session for compliance with the ISO9660 file naming rules. Without this option, only names longer than 31 characters are checked, as these files are a serious violation of the ISO9660 standard.

-check-session file
    (not supported by pycdlib-genisoimage) Check all old sessions for compliance with actual pycdlib-genisoimage ISO9660 file naming rules. This is a high-level option that combines -M file -C 0,0 -check-oldnames. For the parameter file, see the description of -M.

-checksum_algorithm_iso alg1,alg2,...
    (not supported by pycdlib-genisoimage) Specify the checksum types desired for the output image.

-checksum_algorithm_template alg1,alg2,...
    (not supported by pycdlib-genisoimage) Specify the checksum types desired for the output jigdo template.

-copyright file
    Specifies copyright information, typically a filename on the disc. There is space for 37 characters.

-d

-omit-period
    (not supported by pycdlib-genisoimage) Do not append a period to files that do not have one.
    This violates the ISO9660 standard, but it happens to work on many systems. Use with caution.

-D

-disable-deep-relocation
    (not supported by pycdlib-genisoimage) Do not use deep directory relocation, and instead just pack them in the way we see them.
    If ISO9660:1999 has not been selected, this violates the ISO9660 standard, but it happens to work on many systems. Use with caution.

-data-change-warn
    (not supported by pycdlib-genisoimage) If the size of a file changes while the file is being archived, treat this condition as a warning only that does not cause pycdlib-genisoimage to abort.

-debug
    (not supported by pycdlib-genisoimage) Set debug flag.

-dir-mode mode
    (not supported by pycdlib-genisoimage) Overrides the mode of directories used to create the image to mode, specified as 4 digits of permission bits as in chmod(1). This option automatically enables Rock Ridge extensions.

-dvd-video
    (not supported by pycdlib-genisoimage) Generate a DVD-Video compliant UDF filesystem. This is done by sorting the order of the content of the appropriate files and by adding padding between the files if needed. Note that the sorting only works if the DVD-Video filenames include uppercase characters only.

    Note that in order to get a DVD-Video compliant filesystem image, you need to prepare a DVD-Video compliant directory tree. This requires a directory VIDEO_TS (all caps) in the root directory of the resulting DVD, and usually another directory AUDIO_TS. VIDEO_TS needs to include all needed files (filenames must be all caps) for a compliant DVD-Video filesystem.

-e efi_boot_file

-efi-boot efi_boot_file
    Set EFI boot image name.

-f

-follow-links
    (not supported by pycdlib-genisoimage) Follow symbolic links when generating the filesystem. When this option is not in use, symbolic links will be entered using Rock Ridge if enabled, otherwise they will be ignored.

-file-mode mode
    (not supported by pycdlib-genisoimage) Overrides the mode of regular files used to create the image to mode, specified as 4 digits of permission bits as in chmod(1). This option automatically enables Rock Ridge extensions.

-find
    (not supported by pycdlib-genisoimage) This option acts a separator. If it is used, all pycdlib-genisoimage options must be to the left of the -find option. To the right of the -find option, pycdlib-genisoimage accepts the find command line syntax only.

    The find expression acts as a filter between the source of file names and the consumer, which is archiving engine. If the find expression evaluated as TRUE, then the related file is selected for processing, otherwise it is omited.

    In order to make the evaluation of the find expression more convenient, pycdlib-genisoimage implements additional find primaries that have side effects on the file meta data. pycdlib-genisoimage implements the following additional find primaries:

    -help
        Lists the available find(1) syntax.

    -chgrp gname
        The primary always evaluates as true; it sets the group of the file to gname.

    -chmod mode
        The primary always evaluates as true; it sets the permissions of the file to mode. Octal and symbolic permissions are accepted for mode as with chmod(1).

    -chown uname
        The primary always evaluates as true; it sets the owner of the file to uname.

    -false
        The primary always evaluates as false; it allows to make the result of the full expression different from the result of a part of the expression.

    -true
        The primary always evaluates as true; it allows to make the result of the full expression different from the result of a part of the expression.

    The command line:

    pycdlib-genisoimage -o o.iso -find . ( -type d -ls -o false ) -o ! -type d

    lists all directories and puts all non-directories to the image o.iso.

    The command line:

    pycdlib-genisoimage -o o.iso -find . ( -type d -chown root -o true )

    archives all directories so they appear to be owned by root in the archive, all non-directories are archived as they are in the file system.

    Note that the -ls, -exec and the -ok primary cannot be used if stdin or stdout has not been redirected.

-gid gid
    (not supported by pycdlib-genisoimage) Overrides the group ID read from the source files to the value of gid. Specifying this option automatically enables Rock Ridge extensions.

-gui
    (not supported by pycdlib-genisoimage) Switch the behaviour for a GUI. This currently makes the output more verbose but may have other effects in the future.

-graft-points
    (not supported by pycdlib-genisoimage) Allow use of graft points for filenames. If this option is used, all filenames are checked for graft points. The filename is divided at the first unescaped equal sign. All occurrences of `\' and `=' characters must be escaped with `\' if -graft-points has been specified.

-hide glob
    Hide any files matching glob, a shell wildcard pattern, from being seen in the ISO9660 or Rock Ridge directory. glob may match any part of the filename or path. If glob matches a directory, the contents of that directory will be hidden. In order to match a directory name, make sure the pathname does not include a trailing `/' character. All the hidden files will still be written to the output CD image file. See also -hide-joliet, and README.hide. This option may be used multiple times.

-hide-list file
    A file containing a list of shell wildcards to be hidden. See -hide.

-hidden glob
    Add the hidden (existence) ISO9660 directory attribute for files and directories matching glob, a shell wildcard pattern. This attribute will prevent the files from being shown by some MS-DOS and Windows commands. glob may match any part of the filename or path. In order to match a directory name, make sure the pathname does not include a trailing `/' character. This option may be used multiple times.

-hidden-list file
    A file containing a list of shell wildcards to get the hidden attribute. See -hidden.

-hide-joliet glob
    Hide files and directories matching glob, a shell wildcard pattern, from being seen in the Joliet directory. glob may match any part of the filename or path. If glob matches a directory, the contents of that directory will be hidden. In order to match a directory name, make sure the pathname does not include a trailing `/' character. All the hidden files will still be written to the output CD image file. This option is usually used with -hide. See also README.hide. This option may be used multiple times.

-hide-joliet-list file
    A file containing a list of shell wildcards to be hidden from the Joliet tree. See -hide-joliet.

-hide-joliet-trans-tbl
    (not supported by pycdlib-genisoimage) Hide the TRANS.TBL files from the Joliet tree. These files usually don't make sense in the Joliet world as they list the real name and the ISO9660 name which may both be different from the Joliet name.

-hide-rr-moved
    Rename the directory RR_MOVED to .rr_moved in the Rock Ridge tree. It seems to be impossible to completely hide the RR_MOVED directory from the Rock Ridge tree. This option only makes the visible tree less confusing for people who don't know what this directory is for. If you need to have no RR_MOVED directory at all, you should use -D. Note that if -D has been specified, the resulting filesystem is not ISO9660 level-1 compliant and will not be readable on MS-DOS. See also the NOTES section.

-hide-udf glob
    Hide glob from being seen on the UDF directory. glob is a shell wild-card-style pattern that must match any part of the filename or path. Multiple globs may be hidden. If glob matches a directory, then the contents of that directory will be hidden. In order to match a directory name, make sure the pathname does not include a trailing '/' character. All the hidden files will still be written to the output CD image file. Should be used with the -hide option.

-hide-udf-list file
    A file containing a list of globs to be hidden as above.

-input-charset charset
    (not supported by pycdlib-genisoimage) Input charset that defines the characters used in local filenames. To get a list of valid charset names, call pycdlib-genisoimage -input-charset help. To get a 1:1 mapping, you may use default as charset name. The default initial values are cp437 on DOS-based systems and iso8859-1 on all other systems.

-output-charset charset
    (not supported by pycdlib-genisoimage) Output charset that defines the characters that will be used in Rock Ridge filenames. Defaults to the input charset. See CHARACTER SETS section below for more details.

-iso-level level
    Set the ISO9660 conformance level. Valid numbers are 1 to 4.

    With level 1, files may only consist of one section and filenames are restricted to 8.3 characters.

    With level 2, files may only consist of one section.

    With level 3, no restrictions (other than ISO-9660:1988) do apply.

    With all ISO9660 levels from 1 to 3, all filenames are restricted to uppercase letters, numbers and underscores (_). Filenames are limited to 31 characters, directory nesting is limited to 8 levels, and pathnames are limited to 255 characters.

    Level 4 officially does not exist but pycdlib-genisoimage maps it to ISO-9660:1999, which is ISO9660 version 2.

    With level 4, an enhanced volume descriptor with version number and file structure version number set to 2 is emitted. Directory nesting is not limited to 8 levels, there is no need for a file to contain a dot and the dot has no special meaning, filenames do not have version numbers, and filenames can be up to 207 characters long, or 197 characters if Rock Ridge is used.

    When creating Version 2 images, pycdlib-genisoimage emits an enhanced volume descriptor, similar but not identical to a primary volume descriptor. Be careful not to use broken software to make ISO9660 images bootable by assuming a second PVD copy and patching this putative PVD copy into an El Torito VD.

-J  Generate Joliet directory records in addition to regular ISO9660 filenames. This is primarily useful when the discs are to be used on Windows machines. Joliet filenames are specified in Unicode and each path component can be up to 64 Unicode characters long. Note that Joliet is not a standard — only Microsoft Windows and Linux systems can read Joliet extensions. For greater portability, consider using both Joliet and Rock Ridge extensions.

-joliet-long
    (not supported by pycdlib-genisoimage) Allow Joliet filenames to be up to 103 Unicode characters, instead of 64. This breaks the Joliet specification, but appears to work. Use with caution.

-jcharset charset
    (not supported by pycdlib-genisoimage) A combination of -J -input-charset charset.

-l

-full-iso9660-filenames
    (not supported by pycdlib-genisoimage) Allow full 31-character filenames. Normally the ISO9660 filename will be in an 8.3 format which is compatible with MS-DOS, even though the ISO9660 standard allows filenames of up to 31 characters. If you use this option, the disc may be difficult to use on a MS-DOS system, but will work on most other systems. Use with caution.

-L  Outdated option; use -allow-leading-dots instead.

-jigdo-jigdo jigdo_file
    (not supported by pycdlib-genisoimage) Produce a jigdo .jigdo metadata file as well as the filesystem image.

-jigdo-template template_file
    (not supported by pycdlib-genisoimage) Produce a jigdo .template file as well as the filesystem image.

-jigdo-min-file-size size
    (not supported by pycdlib-genisoimage) Specify the minimum size for a file to be listed in the .jigdo file. Default (and minimum allowed) is 1KB.

-jigdo-force-md5 path
    (not supported by pycdlib-genisoimage) Specify a file pattern where files must be contained in the externally-supplied MD5 list as supplied by -md5-list.

-jigdo-exclude path
    (not supported by pycdlib-genisoimage) Specify a file pattern where files will not be listed in the .jigdo file.

-jigdo-map path
    (not supported by pycdlib-genisoimage) Specify a pattern mapping for the jigdo file (e.g. Debian=/mirror/debian).

-md5-list md5_file
    (not supported by pycdlib-genisoimage) Specify a file containing the MD5sums, sizes and pathnames of the files to be included in the .jigdo file.

-jigdo-template-compress algorithm
    (not supported by pycdlib-genisoimage) Specify a compression algorithm to use for template date. gzip and bzip2 are currently supported, and gzip is the default.

-log-file log_file
    Redirect all error, warning and informational messages to log_file instead of the standard error.

-long-rr-time
    (not supported by pycdlib-genisoimage) Use the long ISO-9660 time format for the file time stamps used in Rock Ridge. This time format allows to represent year 0 .. year 9999 with a granularity of 10ms.

    The short ISO-9660 time format only allows to represent year 1900 .. year 2155 with a granularity of 1s.

-m glob
    Exclude files matching glob, a shell wildcard pattern, from being written to CD-ROM. glob may match either the filename component or the full pathname. This option may be used multiple times. For example:

         pycdlib-genisoimage -o rom -m '*.o' -m core -m foobar

    would exclude all files ending in `.o', or called core or foobar from the image. Note that if you had a directory called foobar, it too (and of course all its descendants) would be excluded.

-exclude-list file
    A file containing a list of shell wildcards to be excluded. See -m.

-max-iso9660-filenames
    (not supported by pycdlib-genisoimage) Allow ISO9660 filenames to be up to 37 characters long. This option enables -N as the extra name space is taken from the space reserved for file version numbers.
    This violates the ISO9660 standard, but it happens to work on many systems. Although a conforming application needs to provide a buffer space of at least 37 characters, discs created with this option may cause a buffer overflow in the reading operating system. Use with extreme care.

-M path

-M device

-dev device
    (not supported by pycdlib-genisoimage) Specifies path to existing ISO9660 image to be merged. The alternate form takes a SCSI device specifier that uses the same syntax as the dev= parameter of wodim. The output of pycdlib-genisoimage will be a new session which should get written to the end of the image specified in -M. Typically this requires multisession capability for the CD recorder used to write the image. This option may only be used in conjunction with -C.

-modification-date date-spec
    (not supported by pycdlib-genisoimage) Set the modification date in the primary volume descriptor (PVD) to a value different from the current time. This allows e.g. to set up an intentional UUID for grub.

    The format of date-spec is:

    	yyyy[mm[dd[hh[mm[ss]]]]][.hh][+-ghgm]

    The fields are year, month, day of month, hour, minute, second, hundreds of a second, GMT offset in hours and minutes. The time is interpreted as local time.

    Year and the GMT offset are four digit fields, all other fields take two digits. The GMT offset may be between -12 and +13 hours in 15 minute steps. Locations east to Greenwich have positive values. The value is the sum of the time zone offset and the effects from daylight saving time. Omited values are replaced by the minimal possible values. If the GMT offset is omited, it is computed from the local time value that has been supplied.

    Between year and month as well as between month and day of month, a separator chosen from '/' and '-' may appear. In this case, the year may be a two digit number with values 69..99 representing 1969..1999 and values 00..68 representing 2000..2068. Between date and time spec, an optional space is permitted. Between hours and minutes as well as between minutes and seconds, an optional ':' separator is permitted. This allows pycdlib-genisoimage to parse the popular POSIX date format created by:

    	date "+%Y-%m-%d %H:%M:%S %z"

    Note that the possible range for date-spec for 32 bit programs is limited to values up to 2038 Jan 19 04:14:07 GMT.

-N

-omit-version-number
    (not supported by pycdlib-genisoimage) Omit version numbers from ISO9660 filenames.
    This violates the ISO9660 standard, but no one really uses the version numbers anyway. Use with caution.

-new-dir-mode mode
    (not supported by pycdlib-genisoimage) Specify the mode, a 4-digit number as used in chmod(1), to use when creating new directories in the filesystem image. The default is 0555.

-nobak

-no-bak
    Exclude backup files files on the ISO9660 filesystem; that is, filenames that contain the characters `~' or `#' or end in .bak. These are typically backup files for Unix text editors.

-no-limit-pathtables
    (not supported by pycdlib-genisoimage) A ISO-9660 filesystem contains path tables that contain a list of directories. This list may contain many directories but only 65535 of them may be parent directories. When -no-limit-pathtables is in use, further parent directories will be folded to the root directory and the resulting filesystem will no longer be usable on DOS.

-no-long-rr-time
    (not supported by pycdlib-genisoimage) Use the short ISO-9660 time format for the file time stamps used in Rock Ridge. This time format allows to represent year 1990 .. year 2155 with a granularity of one second.

-force-rr
    (not supported by pycdlib-genisoimage) Do not use the automatic Rock Ridge attributes recognition for previous sessions. This can work around problems with images created by, e.g., NERO Burning ROM.

-no-rr
    (not supported by pycdlib-genisoimage) Do not use the Rock Ridge attributes from previous sessions. This may help to avoid problems when pycdlib-genisoimage finds illegal Rock Ridge signatures on an old session.

-no-split-symlink-components
    (not supported by pycdlib-genisoimage) Don't split the symlink components, but begin a new Continuation Area (CE) instead. This may waste some space, but the SunOS 4.1.4 cdrom driver has a bug in reading split symlink components.

    It is questionable whether this option is useful nowadays.

-no-split-symlink-fields
    (not supported by pycdlib-genisoimage) Don't split the symlink fields, but begin a new Continuation Area (CE) instead. This may waste some space, but the SunOS 4.1.4 and Solaris 2.5.1 cdrom driver have a bug in reading split symlink fields (a `/' can be dropped).

    It is questionable whether this option is useful nowadays.

-o filename
    Specify the output file for the the ISO9660 filesystem image. This can be a disk file, a tape drive, or it can correspond directly to the device name of the optical disc writer. If not specified, stdout is used. Note that the output can also be a block device for a regular disk partition, in which case the ISO9660 filesystem can be mounted normally to verify that it was generated correctly.

-pad
    (not supported by pycdlib-genisoimage) Pad the end of the whole image by 150 sectors (300 kB). This option is enabled by default. If used in combination with -B, padding is inserted between the ISO9660 partition and the boot partitions, such that the first boot partition starts on a sector number that is a multiple of 16.

    The padding is needed as many operating systems (e.g. Linux) implement read-ahead bugs in their filesystem I/O. These bugs result in read errors on files that are located near the end of a track, particularly if the disc is written in Track At Once mode, or where a CD audio track follows the data track.

-no-pad
    (not supported by pycdlib-genisoimage) Do not pad the end by 150 sectors (300 kB) and do not make the the boot partitions start on a multiple of 16 sectors.

-path-list file
    A file containing a list of pathspec directories and filenames to be added to the ISO9660 filesystem. This list of pathspecs are processed after any that appear on the command line. If the argument is -, the list is read from the standard input.

-P  Outdated option; use -publisher instead.

-publisher publisher_id
    Specifies a text string that will be written into the volume header. This should describe the publisher of the CD-ROM, usually with a mailing address and phone number. There is space for 128 characters.

-p preparer_id

-preparer preparer_id
    Specifies a text string that will be written into the volume header. This should describe the preparer of the CD-ROM, usually with a mailing address and phone number. There is space on the disc for 128 characters of information. The related Joliet entry is limited to 64 characters.

-posix-H
    (not supported by pycdlib-genisoimage) Follow all symbolic links encountered on command line when generating the filesystem.

-posix-L
    (not supported by pycdlib-genisoimage) Follow all symbolic links when generating the filesystem. When this option is not in use, symbolic links will be entered using Rock Ridge if enabled, otherwise the file will be ignored.

-posix-P
    (not supported by pycdlib-genisoimage) Do not follow symbolic links when generating the filesystem (this is the default). If -posix-P is specified after -posix-H or -posix-L, the effect of these options will be reset.

-print-size
    Print estimated filesystem size in multiples of the sector size (2048 bytes) and exit. This option is needed for Disk At Once mode and with some CD-R drives when piping directly into wodim, cases where wodim needs to know the size of the filesystem image in advance. Old versions of mkisofs wrote this information (among other information) to stderr. As this turns out to be hard to parse, the number without any other information is now printed on stdout too. If you like to write a simple shell script, redirect stderr and catch the number from stdout. This may be done with:

         cdblocks=` pycdlib-genisoimage -print-size -quiet ... `
         pycdlib-genisoimage ... | wodim ... tsize=${cdblocks}s -

-quiet
    This makes pycdlib-genisoimage even less verbose. No progress output will be provided.

-R

-rock
    Generate SUSP and RR records using the Rock Ridge protocol to further describe the files on the ISO9660 filesystem.

-r

-rational-rock
    This is like the -R option, but file ownership and modes are set to more useful values. The uid and gid are set to zero, because they are usually only useful on the author's system, and not useful to the client. All the file read bits are set true, so that files and directories are globally readable on the client. If any execute bit is set for a file, set all of the execute bits, so that executables are globally executable on the client. If any search bit is set for a directory, set all of the search bits, so that directories are globally searchable on the client. All write bits are cleared, because the filesystem will be mounted read-only in any case. If any of the special mode bits are set, clear them, because file locks are not useful on a read-only filesystem, and set-id bits are not desirable for uid 0 or gid 0. When used on Win32, the execute bit is set on all files. This is a result of the lack of file permissions on Win32 and the Cygwin POSIX emulation layer. See also -uid, -gid, -dir-mode, -file-mode and -new-dir-mode.

-relaxed-filenames
    (not supported by pycdlib-genisoimage) Allows ISO9660 filenames to include all 7-bit ASCII characters except lowercase letters.
    This violates the ISO9660 standard, but it happens to work on many systems. Use with caution.

-root dir
    (not supported by pycdlib-genisoimage) Moves all files and directories into dir in the image. This is essentially the same as using -graft-points and adding dir in front of every pathspec, but is easier to use. dir may actually be several levels deep. It is created with the same permissions as other graft points.

-rrip110
    Create ISO-9660 file system images that follow the old Rrip Version-1.10 standard from 1993. This option may be needed if you know of systems that do not implement the Rrip protocol correctly and like the file system to be read by such a system. Currently no such system is known.

    If a file system has been created with -rrip110, the Rock Ridge attributes do not include inode number information.

-rrip112
    Create ISO-9660 file system images that follow the new Rrip Version-1.12 standard from 1994.

-old-root dir
    (not supported by pycdlib-genisoimage) This option is necessary when writing a multisession image and the previous (or even older) session was written with -root dir. Using a directory name not found in the previous session causes pycdlib-genisoimage to abort with an error. Without this option, pycdlib-genisoimage would not be able to find unmodified files and would be forced to write their data into the image once more. -root and -old-root are meant to be used together to do incremental backups. The initial session would e.g. use: pycdlib-genisoimage -root backup_1 dirs. The next incremental backup with pycdlib-genisoimage -root backup_2 -old-root backup_1 dirs would take another snapshot of these directories. The first snapshot would be found in backup_1, the second one in backup_2, but only modified or new files need to be written into the second session. Without these options, new files would be added and old ones would be preserved. But old ones would be overwritten if the file was modified. Recovering the files by copying the whole directory back from CD would also restore files that were deleted intentionally. Accessing several older versions of a file requires support by the operating system to choose which sessions are to be mounted.

-s sector type

-sectype sector type
    (not supported by pycdlib-genisoimage) Set output sector type to e.g. data/xa1/raw.

-sort sort_file
    (not supported by pycdlib-genisoimage) Sort file locations on the media. Sorting is controlled by a file that contains pairs of filenames and sorting offset weighting. If the weighting is higher, the file will be located closer to the beginning of the media, if the weighting is lower, the file will be located closer to the end of the media. There must be only one space or tabs character between the filename and the weight and the weight must be the last characters on a line. The filename is taken to include all the characters up to, but not including the last space or tab character on a line. This is to allow for space characters to be in, or at the end of a filename. This option does not sort the order of the filenames that appear in the ISO9660 directory. It sorts the order in which the file data is written to the CD image, which is useful in order to optimize the data layout on a CD. See README.sort for more details.

-sparc-boot img_sun4,img_sun4c,img_sun4m,img_sun4d,img_sun4e
    (not supported by pycdlib-genisoimage) See -B above.

-sparc-label label
    (not supported by pycdlib-genisoimage) Set the Sun disk label name for the Sun disk label that is created with -sparc-boot.

-split-output
    (not supported by pycdlib-genisoimage) Split the output image into several files of approximately 1 GB each. This helps to create DVD-sized ISO9660 images on operating systems without large file support. wodim will concatenate more than one file into a single track if writing to a DVD. To make -split-output work, -o filename must be specified. The resulting output images will be named: filename_00, filename_01, filename_02....

-stream-media-size #
    (not supported by pycdlib-genisoimage) Select streaming operation and set the media size to # sectors. This allows you to pipe the output of the tar(1) program into pycdlib-genisoimage and to create an ISO9660 filesystem without the need of an intermediate tar archive file. If this option has been specified, pycdlib-genisoimage reads from stdin and creates a file with the name STREAM.IMG. The maximum size of the file (with padding) is 200 sectors less than the specified media size. If -no-pad has been specified, the file size is 50 sectors less than the specified media size. If the file is smaller, pycdlib-genisoimage will write padding. This may take awhile.

    The option -stream-media-size creates simple ISO9660 filesystems only and may not used together with multisession or hybrid filesystem options.

-stream-file-name name
    Reserved for future use.

-sunx86-boot UFS_img,,,AUX1_img
    (not supported by pycdlib-genisoimage) Specifies a comma-separated list of filesystem images that are needed to make a bootable CD for Solaris x86 systems.

    Note that partition 1 is used for the ISO9660 image and that partition 2 is the whole disk, so partition 1 and 2 may not be used by external partition data. The first image file is mapped to partition 0. There may be empty fields in the comma-separated list, and list entries for partition 1 and 2 must be empty. The maximum number of supported partitions is 8 (although the Solaris x86 partition table could support up to 16 partitions), so it is impossible to specify more than 6 partition images. This option is required to make a bootable CD for Solaris x86 systems.

    If -sunx86-boot has been specified, the first sector of the resulting image will contain a PC fdisk label with a Solaris type 0x82 fdisk partition that starts at offset 512 and spans the whole CD. In addition, for the Solaris type 0x82 fdisk partition, there is a SVr4 disk label at offset 1024 in the first sector of the CD. This disk label specifies slice 0 for the first (usually UFS type) filesystem image that is used to boot the PC and slice 1 for the ISO9660 image. Slice 2 spans the whole CD slice 3 ... slice 7 may be used for additional filesystem images that have been specified with this option.

    A Solaris x86 boot CD uses a 1024 byte sized primary boot that uses the El-Torito no-emulation boot mode and a secondary generic boot that is in CD sectors 1..15. For this reason, both -b bootimage -no-emul-boot and -G genboot must be specified.

-sunx86-label label
    (not supported by pycdlib-genisoimage) Set the SVr4 disk label name for the SVr4 disk label that is created with -sunx86-boot.

-sysid ID
    Specifies the system ID. There is space for 32 characters.

-T

-translation-table
    (not supported by pycdlib-genisoimage) Generate a file TRANS.TBL in each directory on the CD-ROM, which can be used on non-Rock Ridge-capable systems to help establish the correct filenames. There is also information present in the file that indicates the major and minor numbers for block and character devices, and each symlink has the name of the link file given.

-table-name table_name
    (not supported by pycdlib-genisoimage) Alternative translation table filename (see above). Implies -T. If you are creating a multisession image you must use the same name as in the previous session.

-ucs-level level
    Set Unicode conformance level in the Joliet SVD. The default level is 3. It may be set to 1..3 using this option.

-UDF
    Include a UDF hybrid in the generated filesystem image. As pycdlib-genisoimage always creates a ISO-9660 filesystem, it is not possible to create UDF only images. Note that UDF wastes the space from sector ~20 to sector 256 at the beginning of the disk in addition to the space needed for real UDF data structures.

-udf
    Rationalized UDF with user and group set to 0 and with simplified permissions. See -r option for more information.

-udf-symlinks
    Support symlinks in UDF filesystems. This is the default.

-no-udf-symlinks
    Do not support symlinks in UDF filesystems.

-uid uid
    (not supported by pycdlib-genisoimage) Overrides the uid read from the source files to the value of uid. Specifying this option automatically enables Rock Ridge extensions.

-use-fileversion
    (not supported by pycdlib-genisoimage) The option -use-fileversion allows pycdlib-genisoimage to use file version numbers from the filesystem. If the option is not specified, pycdlib-genisoimage creates a version number of 1 for all files. File versions are strings in the range ;1 to ;32767 This option is the default on VMS.

-U

-untranslated-filenames
    (not supported by pycdlib-genisoimage) Allows "untranslated" filenames, completely violating the ISO9660 standards described above. Enables the following flags: -d -l -N -allow-leading-dots -relaxed-filenames -allow-lowercase -allow-multidot -no-iso-translate. Allows more than one `.' character in the filename, as well as mixed-case filenames. This is useful on HP-UX, where the built-in cdfs filesystem does not recognize any extensions. Use with extreme caution.

-no-iso-translate
    (not supported by pycdlib-genisoimage) Do not translate the characters `#' and `~' which are invalid for ISO9660 filenames. Although invalid, these characters are often used by Microsoft systems.
    This violates the ISO9660 standard, but it happens to work on many systems. Use with caution.

-V volid
    Specifies the volume ID (volume name or label) to be written into the master block. There is space for 32 characters. The volume ID is used as the mount point by the Solaris volume manager and as a label assigned to a disc on various other platforms such as Windows and Apple Mac OS.

-volset ID
    Specifies the volume set ID. There is space for 128 characters.

-volset-size #
    Sets the volume set size to #. The volume set size is the number of CDs that are in a CD volume set. A volume set is a collection of one or more volumes, on which a set of files is recorded.

    Volume Sets are not intended to be used to create a set numbered CDs that are part of e.g. a Operation System installation set of CDs. Volume Sets are rather used to record a big directory tree that would not fit on a single volume. Each volume of a Volume Set contains a description of all the directories and files that are recorded on the volumes where the sequence numbers are less than, or equal to, the assigned Volume Set Size of the current volume.

    pycdlib-genisoimage currently does not support a -volset-size that is larger than 1.

    The option -volset-size must be specified before -volset-seqno on each command line.

-volset-seqno #
    Sets the volume set sequence number to #. The volume set sequence number is the index number of the current CD in a CD set. The option -volset-size must be specified before -volset-seqno on each command line.

-v

-verbose
    Verbose execution. If given twice on the command line, extra debug information will be printed.

-x glob
    Identical to -m glob.

-XA Generate XA directory attruibutes.

-xa Generate rationalized XA directory attruibutes.

-z

-transparent-compression
    (not supported by pycdlib-genisoimage) Generate special RRIP records for transparently compressed files. This is only of use and interest for hosts that support transparent decompression, such as Linux 2.4.14 or later. You must specify -R or -r to enable Rock Ridge, and generate compressed files using the mkzftree utility before running pycdlib-genisoimage. Note that transparent compression is a nonstandard Rock Ridge extension. The resulting disks are only transparently readable if used on Linux. On other operating systems you will need to call mkzftree by hand to decompress the files.

-scan-for-duplicates
    Keep a running list of file hashes, attempting to link as many files together as possible. This results in the smallest possible ISO image, but may be very slow, particular with large files.

HFS OPTIONS

-hfs
    (not supported by pycdlib-genisoimage) Create an ISO9660/HFS hybrid CD. This option should be used in conjunction with the -map, -magic and/or the various double dash options given below.

-no-hfs
    Do not create an ISO-9660/HFS hybrid CD even though other options may imply to do so.

-apple
    (not supported by pycdlib-genisoimage) Create an ISO9660 CD with Apple's extensions. Similar to -hfs, except that the Apple Extensions to ISO9660 are added instead of creating an HFS hybrid volume. Former pycdlib-genisoimage versions did include Rock Ridge attributes by default if -apple was specified. This versions of pycdlib-genisoimage does not do this anymore. If you like to have Rock Ridge attributes, you need to specify this separately.

-map mapping_file
    (not supported by pycdlib-genisoimage) Use the mapping_file to set the CREATOR and TYPE information for a file based on the filename's extension. A filename is mapped only if it is not one of the know Apple/Unix file formats.

-magic magic_file
    (not supported by pycdlib-genisoimage) The CREATOR and TYPE information is set by using a file's magic number (usually the first few bytes of a file). The magic_file is only used if a file is not one of the known Apple/Unix file formats, or the filename extension has not been mapped using -map.

-hfs-creator creator
    (not supported by pycdlib-genisoimage) Set the default CREATOR for all files. Must be exactly 4 characters.

-hfs-type type
    (not supported by pycdlib-genisoimage) Set the default TYPE for all files. Must be exactly 4 characters.

-probe
    (not supported by pycdlib-genisoimage) Search the contents of files for all the known Apple/Unix file formats. However, the only way to check for MacBinary and AppleSingle files is to open and read them, so this option may increase processing time. It is better to use one or more double dash options given below if the Apple/Unix formats in use are known.

-no-desktop
    (not supported by pycdlib-genisoimage) Do not create (empty) Desktop files. New HFS Desktop files will be created when the CD is used on a Macintosh (and stored in the System Folder). By default, empty Desktop files are added to the HFS volume.

-mac-name
    (not supported by pycdlib-genisoimage) Use the HFS filename as the starting point for the ISO9660, Joliet and Rock Ridge filenames.

-boot-hfs-file driver_file
    (not supported by pycdlib-genisoimage) Installs the driver_file that may make the CD bootable on a Macintosh.

-part
    (not supported by pycdlib-genisoimage) Generate an HFS partition table. By default, no partition table is generated, but some older Macintosh CD-ROM drivers need an HFS partition table on the CD-ROM to be able to recognize a hybrid CD-ROM.

-auto AutoStart_file
    (not supported by pycdlib-genisoimage) Make the HFS CD use the QuickTime 2.0 Autostart feature to launch an application or document. The given filename must be the name of a document or application located at the top level of the CD. The filename must be less than 12 characters. (Alpha).

-cluster-size size
    (not supported by pycdlib-genisoimage) Set the size in bytes of the cluster or allocation units of PC Exchange files. Implies --exchange.

-hide-hfs glob
    (not supported by pycdlib-genisoimage) Hide glob, a shell wildcard pattern, from the HFS volume. The file or directory will still exist in the ISO9660 and/or Joliet directory. glob may match any part of the filename. Multiple globs may be excluded. Example:

         pycdlib-genisoimage -o rom -hfs -hide-hfs '*.o' -hide-hfs foobar

    would exclude all files ending in `.o' or called foobar from the HFS volume. Note that if you had a directory called foobar, it too (and of course all its descendants) would be excluded. The glob can also be a path name relative to the source directories given on the command line. Example:

         pycdlib-genisoimage -o rom -hfs -hide-hfs src/html src

    would exclude just the file or directory called html from the src directory. Any other file or directory called html in the tree will not be excluded. Should be used with -hide and/or -hide-joliet. In order to match a directory name, make sure the pattern does not include a trailing `/' character. See README.hide for more details.

-hide-hfs-list file
    (not supported by pycdlib-genisoimage) Specify a file containing a list of wildcard patterns to be hidden as in -hide-hfs.

-hfs-volid hfs_volid
    (not supported by pycdlib-genisoimage) Volume name for the HFS partition. This is the name that is assigned to the disc on a Macintosh and replaces the volid used with -V.

-icon-position
    (not supported by pycdlib-genisoimage) Use the icon position information, if it exists, from the Apple/Unix file. The icons will appear in the same position as they would on a Macintosh desktop. Folder location and size on screen, its scroll positions, folder View (view as Icons, Small Icons, etc.) are also preserved. (Alpha).

-root-info file
    (not supported by pycdlib-genisoimage) Set the location, size on screen, scroll positions, folder View etc. for the root folder of an HFS volume. See README.rootinfo for more information. (Alpha)

-prep-boot file
    (not supported by pycdlib-genisoimage) PReP boot image file. Up to 4 are allowed. See README.prep_boot for more information. (Alpha)

-chrp-boot
    (not supported by pycdlib-genisoimage) Add CHRP boot header.

-input-hfs-charset charset
    (not supported by pycdlib-genisoimage) Input charset that defines the characters used in HFS filenames when used with -mac-name. The default charset is cp10000 (Mac Roman).

-output-hfs-charset charset
    (not supported by pycdlib-genisoimage) Output charset that defines the characters that will be used in the HFS filenames. Defaults to the input charset.

-hfs-unlock
    (not supported by pycdlib-genisoimage) By default, pycdlib-genisoimage will create an HFS volume that is locked. This option leaves the volume unlocked so that other applications (e.g. hfsutils) can modify the volume.

-hfs-bless folder_name
    (not supported by pycdlib-genisoimage) "Bless" the given directory (folder). This is usually the System Folder and is used in creating HFS bootable CDs. The name of the directory must be the whole path name as pycdlib-genisoimage sees it. E.g., if the given pathspec is ./cddata and the required folder is called System Folder, the whole path name is "/cddata/System Folder" (remember to use quotes if the name contains spaces).

-hfs-parms parameters
    (not supported by pycdlib-genisoimage) Override certain parameters used to create the HFS filesystem. Unlikely to be used in normal circumstances.

--cap
    (not supported by pycdlib-genisoimage) Look for AUFS CAP Macintosh files. Search for CAP Apple/Unix file formats only. Searching for the other possible Apple/Unix file formats is disabled, unless other double dash options are given.

--netatalk
    (not supported by pycdlib-genisoimage) Look for NETATALK Macintosh files

--double
    (not supported by pycdlib-genisoimage) Look for AppleDouble Macintosh files

--ethershare
    (not supported by pycdlib-genisoimage) Look for Helios EtherShare Macintosh files

--ushare
    (not supported by pycdlib-genisoimage) Look for IPT UShare Macintosh files

--exchange
    (not supported by pycdlib-genisoimage) Look for PC Exchange Macintosh files

--sgi
    (not supported by pycdlib-genisoimage) Look for SGI Macintosh files

--xinet
    (not supported by pycdlib-genisoimage) Look for XINET Macintosh files

--macbin
    (not supported by pycdlib-genisoimage) Look for MacBinary Macintosh files

--single
    (not supported by pycdlib-genisoimage) Look for AppleSingle Macintosh files

--dave
    (not supported by pycdlib-genisoimage) Look for Thursby Software Systems DAVE Macintosh files

--sfm
    (not supported by pycdlib-genisoimage) Look for Microsoft's Services for Macintosh files (NT only) (Alpha)

--osx-double
    (not supported by pycdlib-genisoimage) Look for Mac OS X AppleDouble Macintosh files

--osx-hfs
    (not supported by pycdlib-genisoimage) Look for Mac OS X HFS Macintosh files

SEE ALSO
genisoimage(1), pycdlib-explorer(1), pycdlib-extract-files(1)

AUTHOR
Chris Lalancette <clalancette@gmail.com>